(defun cmpsys (&optional load)
  (flet ((compile-if-needed (file &optional load)
	   (let ((lspfile (merge-pathnames file ".lsp"))
		 (fslfile (merge-pathnames file ".fsl")))
	     (unless (and (probe-file lspfile)
			  (probe-file fslfile)
			  (< (file-write-date lspfile)
			     (file-write-date fslfile)))
		     (compile-file file :load load)))))
    (let ((stdfiles '("common" "common2" "common3" "pathname" "help" "objects"
		      "conditns" "shlib" "loadfsl"))
	  (otherfiles '("init" "cmpload" "linalg" "stats" "dialogs" "graphics"
			"graph2" "graph3" "regress" "menus" "oneway" "nonlin"
			"maximize" "bayes" "stepper" "glim")))
      (dolist (f stdfiles) (compile-if-needed f load))
      (dolist (f otherfiles) (compile-if-needed f)))))

