(in-package "NEWCMP")

(defmacro define-drop-dead-primop-simplifier (name)
  `(define-primop-simplifier ,name (e table)
     (flet ((unused (v) (= (varinfo-count (lookup-varinfo v table)) 0)))
       (let ((vars (primop-vars e))
             (form (primop-form e)))
         (cond
          ((or (and vars (every #'unused vars)) (and (null vars) form))
           (dolist (a (primop-args e))
             (when (var-p a)
                   (decf (varinfo-count (lookup-varinfo a table)))))
           (primop-form e))
          (t e))))))

